<?xml version='1.0'?>
<!DOCTYPE xsl:stylesheet
[
 <!ENTITY % xslpath  PUBLIC "Stylesheet Paths" "xslpath.ent"> %xslpath;
 %mmlalias;
 %mmlextra;
]>
<!--########################################################################### 
 |    $Id: mathml.mod.xsl,v 1.4 2001/05/22 00:55:57 ben Exp $        
 |- ###########################################################################
 |   $Author: ben $
 |
 |   This file comes from the DB2LaTeX XSLT Stylesheets by Ramon Casellas who
 |   accepted its reuse and customization for this package.
 |                                                        
 |   PURPOSE: MathML presentation and content markup.
 |    Note: these elements are not part of the DocBook DTD. I have extended
 |    the docbook DTD in order to support this tags, so that's why I have these 
 |    templates here.
 |   
 |    MathML namespace used -> mml
 + ############################################################################ -->

<xsl:stylesheet version='1.0'
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:mml="http://www.w3.org/1998/Math/MathML" xmlns="http://www.w3.org/1998/Math/MathML">

<xsl:strip-space elements="mml:math mml:mrow"/>


<xsl:template match="mml:math">
  <xsl:text>&#10;\begin_inset Formula </xsl:text>
  <xsl:if test="not(mml:mtable/mml:mlabeledtr)">
    <xsl:text>\[&#10;</xsl:text>
  </xsl:if>
  <xsl:apply-templates/>
  <xsl:if test="not(mml:mtable/mml:mlabeledtr)">
    <xsl:text>\]&#10;</xsl:text>
  </xsl:if>
  <xsl:text>\end_inset&#10;</xsl:text>
</xsl:template>

<xsl:template match="mml:math[@mode='inline']">
  <xsl:text>&#10;\begin_inset Formula \(</xsl:text>
  <xsl:apply-templates mode="mathml.inline"/>
  <xsl:text>\)&#10;\end_inset&#10;</xsl:text>
</xsl:template>

<xsl:template match="mml:math[@mode='display']">
  <xsl:text>&#10;\begin_inset Formula </xsl:text>
  <xsl:if test="not(mml:mtable/mml:mlabeledtr)">
    <xsl:text>\[&#10;</xsl:text>
  </xsl:if>
  <xsl:apply-templates/>
  <xsl:if test="not(mml:mtable/mml:mlabeledtr)">
    <xsl:text>\]&#10;</xsl:text>
  </xsl:if>
  <xsl:text>\end_inset&#10;</xsl:text>
</xsl:template>


<xsl:template match="p">
  <xsl:value-of select="normalize-space(.)"/>
</xsl:template>


<xsl:template match="inlineequation">
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="alt">
</xsl:template>

</xsl:stylesheet>
