<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version='1.0'>
<!--########################################################################### 
 |    $Id: normalize-scape.mod.xsl,v 1.6 2001/05/09 18:53:34 ben Exp $
 |- ###########################################################################
 |   $Author: ben $
 |
 |   This file comes from the DB2LaTeX XSLT Stylesheets by Ramon Casellas who
 |   accepted its reuse and customization for this package.
 |                              
 |   PURPOSE:
 |  Escape LaTeX and normalize-space templates.
 |    # $ % & ~ _ ^ \ { }
 + ############################################################################ -->


<xsl:template match="text()">
<xsl:call-template name="scape">
<xsl:with-param name="string" select="."/>
</xsl:call-template>
</xsl:template>

<xsl:template match="text()" mode="lyx.verbatim">
<xsl:value-of select="."/> 
</xsl:template>

<!-- To do: how to scape tabs? xt plants -->

<!-- Because \layout Code needs to be put at each \n the string is parsed
     in order to detect the \n in the text. However it becomes a problem
     at the end of the text in which \n should not be translated!  -->

<xsl:template match="text()" mode="lyx.programlisting">
<xsl:call-template name="string-replace">
<xsl:with-param name="to">
  <xsl:text>&#10;\layout Code&#10;</xsl:text>
</xsl:with-param>
<xsl:with-param name="from"><xsl:text>&#10;</xsl:text></xsl:with-param>
<xsl:with-param name="string">
  <xsl:call-template name="string-remove-last">
    <xsl:with-param name="torem"><xsl:text>&#10;</xsl:text></xsl:with-param>
    <xsl:with-param name="string" select="."></xsl:with-param>
  </xsl:call-template>
</xsl:with-param>
</xsl:call-template>
<xsl:text>&#10;</xsl:text>
</xsl:template>

<!-- This is the same thing for literal lines except that it is not the same
     LyX layout. The other difference is that it must be aligned to left too.
 -->

<xsl:template match="text()" mode="lyx.literal">
<xsl:call-template name="string-replace">
<xsl:with-param name="to">
  <xsl:text>&#10;\layout Literal&#10;</xsl:text>
</xsl:with-param>
<xsl:with-param name="from"><xsl:text>&#10;</xsl:text></xsl:with-param>
<xsl:with-param name="string">
  <xsl:call-template name="string-remove-last">
    <xsl:with-param name="torem"><xsl:text>&#10;</xsl:text></xsl:with-param>
    <xsl:with-param name="string">
      <xsl:call-template name="string-replace-cyclic">
        <xsl:with-param name="to"><xsl:text>&#10;</xsl:text></xsl:with-param>
        <xsl:with-param name="from"><xsl:text>&#10; </xsl:text></xsl:with-param>
        <xsl:with-param name="string">
          <xsl:value-of select="."/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:with-param>
  </xsl:call-template>
</xsl:with-param>
</xsl:call-template>
<xsl:text>&#10;</xsl:text>
</xsl:template>

<xsl:template name="normalize-scape" >
<xsl:param name="string"/>
<xsl:variable name="result">
  <xsl:call-template name="scape"><xsl:with-param name="string" select="$string"/></xsl:call-template>
</xsl:variable>
<xsl:value-of select="normalize-space($result)"/>
</xsl:template>


<xsl:template name="scape" >
<xsl:param name="string"/>
<xsl:call-template name="string-replace">
<xsl:with-param name="to">&lt;</xsl:with-param>
<xsl:with-param name="from">&lt;</xsl:with-param>
<xsl:with-param name="string">
  <xsl:call-template name="string-replace">
    <xsl:with-param name="to">&gt;</xsl:with-param>
    <xsl:with-param name="from">&gt;</xsl:with-param>
    <xsl:with-param name="string">
      <xsl:call-template name="string-replace">
        <xsl:with-param name="to">
          <xsl:text>\backslash&#10;</xsl:text></xsl:with-param>
        <xsl:with-param name="from">\</xsl:with-param>
        <xsl:with-param name="string">
          <xsl:call-template name="string-replace">
            <xsl:with-param name="to">}</xsl:with-param>
            <xsl:with-param name="from">}</xsl:with-param>
            <xsl:with-param name="string">
              <xsl:call-template name="string-replace">
                <xsl:with-param name="to">&amp;</xsl:with-param>
                <xsl:with-param name="from">&amp;</xsl:with-param>
                <xsl:with-param name="string">
                  <xsl:call-template name="string-replace">
                     <xsl:with-param name="to">#</xsl:with-param>
                     <xsl:with-param name="from">#</xsl:with-param>
                    <xsl:with-param name="string">
                      <xsl:call-template name="string-replace">
                        <xsl:with-param name="to">_</xsl:with-param>
                        <xsl:with-param name="from">_</xsl:with-param>
                        <xsl:with-param name="string">
                          <xsl:call-template name="string-replace">
                            <xsl:with-param name="to">$</xsl:with-param>
                            <xsl:with-param name="from">$</xsl:with-param>
                            <xsl:with-param name="string">
                              <xsl:call-template name="string-replace">
                                 <xsl:with-param name="to">%</xsl:with-param>
                                 <xsl:with-param name="from">%</xsl:with-param>
                             <xsl:with-param name="string" select="$string"></xsl:with-param>
                              </xsl:call-template></xsl:with-param>
                          </xsl:call-template></xsl:with-param>
                      </xsl:call-template></xsl:with-param>
                  </xsl:call-template></xsl:with-param>
              </xsl:call-template></xsl:with-param>
            </xsl:call-template></xsl:with-param>
        </xsl:call-template></xsl:with-param>
    </xsl:call-template></xsl:with-param>
</xsl:call-template>
</xsl:template>


<xsl:template name="string-replace-cyclic" >
  <xsl:param name="string"/>
  <xsl:param name="from"/>
  <xsl:param name="to"/>
  <xsl:choose>
    <xsl:when test="contains($string,$from)">
      <xsl:value-of select="substring-before($string,$from)"/>
      <xsl:call-template name="string-replace-cyclic">
        <xsl:with-param name="string">
          <xsl:value-of select="$to"/><xsl:value-of select="substring-after($string,$from)"/>
        </xsl:with-param>
        <xsl:with-param name="from" select="$from"/>
        <xsl:with-param name="to" select="$to"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$string"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template name="string-remove-last" >
  <xsl:param name="string"/>
  <xsl:param name="torem"/>
  <xsl:choose>
    <xsl:when test="contains($string,$torem)">
    <xsl:variable name="next" select="substring-after($string,$torem)"/>
      <xsl:value-of select="substring-before($string,$torem)"/>
      <xsl:choose>
      <xsl:when test="contains($next,$torem)">
        <xsl:value-of select="$torem"/>
        <xsl:call-template name="string-remove-last">
          <xsl:with-param name="string">
            <xsl:value-of select="$next"/>
          </xsl:with-param>
          <xsl:with-param name="torem" select="$torem"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$next"/>
      </xsl:otherwise>
      </xsl:choose>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$string"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<!--  (c) David Carlisle
    replace all occurences of the character(s) `from'
         by the string `to' in the string `string'.
  -->
<xsl:template name="string-replace" >
  <xsl:param name="string"/>
  <xsl:param name="from"/>
  <xsl:param name="to"/>
  <xsl:choose>
    <xsl:when test="contains($string,$from)">
      <xsl:value-of select="substring-before($string,$from)"/>
      <xsl:value-of select="$to"/>
      <xsl:call-template name="string-replace">
          <xsl:with-param name="string" select="substring-after($string,$from)"/>
          <xsl:with-param name="from" select="$from"/>
          <xsl:with-param name="to" select="$to"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$string"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


</xsl:stylesheet>
