<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:doc="http://nwalsh.com/xsl/documentation/1.0"
    exclude-result-prefixes="doc" 
    version='1.0'>

<!--########################################################################## 
 |    $Id: verbatim.mod.xsl,v 1.7 2001/05/19 18:01:07 ben Exp $
 |- ##########################################################################
 |   $Author: ben $
 |
 |   This file comes from the DB2LaTeX XSLT Stylesheets by Ramon Casellas who
 |   accepted its reuse and customization for this package.
 |                                                        
 |   PURPOSE:
 + ########################################################################### -->

<doc:reference xmlns="">
    <referenceinfo>
    <releaseinfo role="meta">
        $Id: verbatim.mod.xsl,v 1.7 2001/05/19 18:01:07 ben Exp $
    </releaseinfo>
    <author>
        <surname>Casellas</surname>
        <firstname>Ramon</firstname>
    </author>
    <copyright><year>2000</year>
        <holder>Ramon Casellas</holder>
    </copyright>
    </referenceinfo>
    
    <title>Verbatim Templates</title>

    <partintro>
        <section><title>Introduction</title>

        <para>This is technical reference documentation for the DocBook XSL
        Stylesheets; it documents (some of) the parameters, templates, and
        other elements of the stylesheets.</para>

        <para>This reference describes the templates and parameters relevant
        to formatting EBNF markup.</para>

        <para>This is not intended to be <quote>user</quote> documentation.
        It is provided for developers writing customization layers for the
        stylesheets, and for anyone who's interested in <quote>how it
        works</quote>.</para>
        </section>
    </partintro>
</doc:reference>


<xsl:template match="screen|literallayout[@class='monospaced']">
<xsl:message>DB2LyX [warning]: Not translated</xsl:message>
<xsl:apply-templates mode="lyx.verbatim"/>
</xsl:template>


<doc:param name="literal template" xmlns="">
<refpurpose>Template for <sgmltag>literal</sgmltag></refpurpose>
<refdescription>
Template for literal template
</refdescription>
</doc:param>

<doc:template name="literal" id="unsupported" xmlns="">
  <refpurpose>command tag</refpurpose>
  <refdescription>
    <para>This element is copied as ERT, since it is inlined.</para>
  </refdescription>
</doc:template>

<xsl:template match="literal">
<xsl:call-template name="unsupported.inline"/>
</xsl:template>

<xsl:template match="literallayout">
<xsl:apply-templates mode="lyx.literal"/>
</xsl:template>

<doc:template name="address" id="unsupported" xmlns="">
  <refpurpose>Adress Element</refpurpose>
  <refdescription>
    <para>This element is copied as SGML, since it is displayed as a block.
    Perhaps this element could easily be supported with a new layout style.
    </para>
  </refdescription>
</doc:template>

<xsl:template match="address">
<xsl:call-template name="unsupported.block"/>
</xsl:template>

</xsl:stylesheet>
